#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;

using Syncfusion.Windows.Forms.Diagram;


namespace Syncfusion.Windows.Forms.Diagram.Samples.ExportImage
{
	
	public class MainForm : System.Windows.Forms.Form
	{
		#region Declarations
		private System.Windows.Forms.Panel panelSymbolPalettes;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupBar paletteGroupBar;
		private System.Windows.Forms.Panel panelProperties;
		private System.Windows.Forms.Panel panelDiagram;
		private Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor propertyEditor;
		private Syncfusion.Windows.Forms.Tools.GroupBarItem groupBarItemTestSymbols;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem fileMenuItem;
		private System.Windows.Forms.MenuItem menuItemFileExit;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView paletteGroupView1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.Panel panelClientPanel;
		private System.Windows.Forms.ToolBarButton toolBarButtonSelect;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBarButton toolBarButtonPan;
		private System.Windows.Forms.ToolBarButton toolBarButtonZoom;
		private System.Windows.Forms.ToolBarButton toolBarButtonGroup;
		private System.Windows.Forms.ToolBarButton toolBarButtonUngroup;
		private System.Windows.Forms.ToolBarButton toolBarButtonLink;
		private System.Windows.Forms.ToolBarButton toolBarButtonPrintPreview;
		private System.Windows.Forms.ToolBarButton toolBarButtonPrint;
		private System.Windows.Forms.MenuItem exportdiagram_menu;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem pdfdocument_menu;
		private System.Windows.Forms.MenuItem menuItem3;
		#endregion
		
		#region Constructors
		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
#if Essential_PDF_Installed
			this.pdfdocument_menu.Click += new System.EventHandler(this.pdfdocument_menu_Click);

			this.fileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.exportdiagram_menu,																					  
																					  this.pdfdocument_menu,
																					  this.menuItem3,
																					  this.menuItemFileExit});
#else
			this.fileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.exportdiagram_menu,																					  																					 
																					  this.menuItem3,
																					  this.menuItemFileExit});
#endif
		}
		#endregion

		#region Dispose Method

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panelSymbolPalettes = new System.Windows.Forms.Panel();
			this.paletteGroupBar = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupBar();
			this.paletteGroupView1 = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView();
			this.groupBarItemTestSymbols = new Syncfusion.Windows.Forms.Tools.GroupBarItem();
			this.panelProperties = new System.Windows.Forms.Panel();
			this.propertyEditor = new Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor();
			this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.panelDiagram = new System.Windows.Forms.Panel();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.fileMenuItem = new System.Windows.Forms.MenuItem();
			this.exportdiagram_menu = new System.Windows.Forms.MenuItem();
			this.pdfdocument_menu = new System.Windows.Forms.MenuItem();
			this.menuItemFileExit = new System.Windows.Forms.MenuItem();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.toolBarButtonSelect = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonPan = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonZoom = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonGroup = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonUngroup = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonLink = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonPrintPreview = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonPrint = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.panelClientPanel = new System.Windows.Forms.Panel();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.panelSymbolPalettes.SuspendLayout();
			this.paletteGroupBar.SuspendLayout();
			this.panelProperties.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).BeginInit();
			this.panelDiagram.SuspendLayout();
			this.panelClientPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// panelSymbolPalettes
			// 
			this.panelSymbolPalettes.Controls.Add(this.paletteGroupBar);
			this.panelSymbolPalettes.Dock = System.Windows.Forms.DockStyle.Left;
			this.panelSymbolPalettes.Location = new System.Drawing.Point(0, 0);
			this.panelSymbolPalettes.Name = "panelSymbolPalettes";
			this.panelSymbolPalettes.Size = new System.Drawing.Size(144, 477);
			this.panelSymbolPalettes.TabIndex = 0;
			// 
			// paletteGroupBar
			// 
			this.paletteGroupBar.AllowDrop = true;
			this.paletteGroupBar.Controls.Add(this.paletteGroupView1);
			this.paletteGroupBar.Dock = System.Windows.Forms.DockStyle.Fill;
			this.paletteGroupBar.EditMode = false;
			this.paletteGroupBar.GroupBarItems.AddRange(new Syncfusion.Windows.Forms.Tools.GroupBarItem[] {
																											  this.groupBarItemTestSymbols});
			this.paletteGroupBar.Location = new System.Drawing.Point(0, 0);
			this.paletteGroupBar.Name = "paletteGroupBar";
			this.paletteGroupBar.SelectedItem = 0;
			this.paletteGroupBar.Size = new System.Drawing.Size(144, 477);
			this.paletteGroupBar.TabIndex = 0;
			this.paletteGroupBar.Text = "paletteGroupBar1";
			// 
			// paletteGroupView1
			// 
			this.paletteGroupView1.BackColor = System.Drawing.Color.LightGray;
			this.paletteGroupView1.EditMode = false;
			this.paletteGroupView1.ForeColor = System.Drawing.SystemColors.HighlightText;
			this.paletteGroupView1.Location = new System.Drawing.Point(2, 24);
			this.paletteGroupView1.Name = "paletteGroupView1";
			this.paletteGroupView1.Size = new System.Drawing.Size(140, 451);
			this.paletteGroupView1.TabIndex = 0;
			this.paletteGroupView1.Text = "paletteGroupView1";
            this.paletteGroupView1.LoadPalette(System.Reflection.Assembly.GetAssembly(typeof(Syncfusion.Windows.Forms.Diagram.Samples.ExportImage.MainForm)), "Syncfusion.Windows.Forms.Diagram.Samples.ExportImage.MainForm", "paletteGroupView1.Palette");
			// 
			// groupBarItemTestSymbols
			// 
			this.groupBarItemTestSymbols.Client = this.paletteGroupView1;
			this.groupBarItemTestSymbols.Text = "Test Symbols";
			// 
			// panelProperties
			// 
			this.panelProperties.Controls.Add(this.propertyEditor);
			this.panelProperties.Dock = System.Windows.Forms.DockStyle.Right;
			this.panelProperties.Location = new System.Drawing.Point(488, 0);
			this.panelProperties.Name = "panelProperties";
			this.panelProperties.Size = new System.Drawing.Size(184, 477);
			this.panelProperties.TabIndex = 1;
			// 
			// propertyEditor
			// 
			this.propertyEditor.BackColor = System.Drawing.SystemColors.Control;
			this.propertyEditor.Diagram = this.diagram1;
			this.propertyEditor.Dock = System.Windows.Forms.DockStyle.Fill;
			this.propertyEditor.Location = new System.Drawing.Point(0, 0);
			this.propertyEditor.Name = "propertyEditor";
			this.propertyEditor.Size = new System.Drawing.Size(184, 477);
			this.propertyEditor.TabIndex = 0;
			// 
			// diagram1
			// 
			this.diagram1.AllowDrop = true;
			// 
			// diagram1.Controller
			// 
			this.diagram1.Controller.MaxHistory = 256;
			this.diagram1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram1.HScroll = true;
			this.diagram1.LayoutManager = null;
			this.diagram1.Location = new System.Drawing.Point(0, 0);
			// 
			// diagram1.Model
			// 
			this.diagram1.Model.HeaderFooterData.Footer.Bounds.Width = 650F;
			this.diagram1.Model.HeaderFooterData.Header.Bounds.Width = 650F;
			this.diagram1.Model.Height = 1056F;
			this.diagram1.Model.LineStyle.LineWidth = 1F;
			this.diagram1.Model.Name = "Model";
			this.diagram1.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
			this.diagram1.Model.Width = 816F;
			this.diagram1.Name = "diagram1";
			this.diagram1.Size = new System.Drawing.Size(344, 477);
			this.diagram1.SmartSizeBox = false;
			this.diagram1.TabIndex = 0;
			this.diagram1.Text = "diagram1";
			// 
			// diagram1.View
			// 
			this.diagram1.View.Grid.Color = System.Drawing.Color.White;
			this.diagram1.VScroll = true;
			// 
			// panelDiagram
			// 
			this.panelDiagram.Controls.Add(this.diagram1);
			this.panelDiagram.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelDiagram.Location = new System.Drawing.Point(144, 0);
			this.panelDiagram.Name = "panelDiagram";
			this.panelDiagram.Size = new System.Drawing.Size(344, 477);
			this.panelDiagram.TabIndex = 2;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.fileMenuItem});
			// 
			// fileMenuItem
			// 
			this.fileMenuItem.Index = 0;
			this.fileMenuItem.Text = "&File";
			// 
			// exportdiagram_menu
			// 
			this.exportdiagram_menu.Index = 0;
			this.exportdiagram_menu.Text = "Export As Image...";
			this.exportdiagram_menu.Click += new System.EventHandler(this.exportdiagram_menu_Click);
			// 
			// pdfdocument_menu
			// 
			this.pdfdocument_menu.Index = 1;
			this.pdfdocument_menu.Text = "Export As PDF Document...";
			// 
			// menuItemFileExit
			// 
			this.menuItemFileExit.Index = 3;
			this.menuItemFileExit.Text = "&Exit";
			this.menuItemFileExit.Click += new System.EventHandler(this.menuItemFileExit_Click);
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.toolBarButtonSelect,
																						this.toolBarButtonPan,
																						this.toolBarButtonZoom,
																						this.toolBarButtonGroup,
																						this.toolBarButtonUngroup,
																						this.toolBarButtonLink,
																						this.toolBarButtonPrintPreview,
																						this.toolBarButtonPrint});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(672, 28);
			this.toolBar1.TabIndex = 3;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// toolBarButtonSelect
			// 
			this.toolBarButtonSelect.ImageIndex = 0;
			this.toolBarButtonSelect.Pushed = true;
			this.toolBarButtonSelect.Tag = "SelectTool";
			this.toolBarButtonSelect.ToolTipText = "Select";
			// 
			// toolBarButtonPan
			// 
			this.toolBarButtonPan.ImageIndex = 1;
			this.toolBarButtonPan.Tag = "PanTool";
			this.toolBarButtonPan.ToolTipText = "Pan";
			// 
			// toolBarButtonZoom
			// 
			this.toolBarButtonZoom.ImageIndex = 2;
			this.toolBarButtonZoom.Tag = "ZoomTool";
			this.toolBarButtonZoom.ToolTipText = "Zoom";
			// 
			// toolBarButtonGroup
			// 
			this.toolBarButtonGroup.ImageIndex = 3;
			this.toolBarButtonGroup.Tag = "GroupTool";
			this.toolBarButtonGroup.ToolTipText = "Group";
			// 
			// toolBarButtonUngroup
			// 
			this.toolBarButtonUngroup.ImageIndex = 4;
			this.toolBarButtonUngroup.Tag = "UngroupTool";
			this.toolBarButtonUngroup.ToolTipText = "Ungroup";
			// 
			// toolBarButtonLink
			// 
			this.toolBarButtonLink.ImageIndex = 5;
			this.toolBarButtonLink.Tag = "LinkTool";
			this.toolBarButtonLink.ToolTipText = "Link";
			// 
			// toolBarButtonPrintPreview
			// 
			this.toolBarButtonPrintPreview.ImageIndex = 6;
			this.toolBarButtonPrintPreview.ToolTipText = "Print Preview";
			// 
			// toolBarButtonPrint
			// 
			this.toolBarButtonPrint.ImageIndex = 7;
			this.toolBarButtonPrint.ToolTipText = "Print";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// panelClientPanel
			// 
			this.panelClientPanel.Controls.Add(this.panelDiagram);
			this.panelClientPanel.Controls.Add(this.panelProperties);
			this.panelClientPanel.Controls.Add(this.panelSymbolPalettes);
			this.panelClientPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelClientPanel.Location = new System.Drawing.Point(0, 28);
			this.panelClientPanel.Name = "panelClientPanel";
			this.panelClientPanel.Size = new System.Drawing.Size(672, 477);
			this.panelClientPanel.TabIndex = 4;			
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 2;
			this.menuItem3.Text = "-";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(672, 505);
			this.Controls.Add(this.panelClientPanel);
			this.Controls.Add(this.toolBar1);
			this.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Menu = this.mainMenu1;
			this.Name = "MainForm";
			this.Text = "Essential Diagram: ExportImage";
			this.panelSymbolPalettes.ResumeLayout(false);
			this.paletteGroupBar.ResumeLayout(false);
			this.panelProperties.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).EndInit();
			this.panelDiagram.ResumeLayout(false);
			this.panelClientPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region MainMethod
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}
		# endregion

		#region Exit Menu Event
		private void menuItemFileExit_Click(object sender, System.EventArgs e)
		{
			//To close the application
			this.Close();
		}	
		#endregion

		#region Toolbar Event

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == this.toolBarButtonPrint)
			{
				//To print the diagram document
				this.Print();
			}
			else if (e.Button == this.toolBarButtonPrintPreview)
			{
				//To preview the diagram document to be printed
				this.PrintPreview();
			}
			else if( e.Button == this.toolBarButtonGroup )
				//Groups the selected symbols
				this.diagram1.Controller.Group();
			else if( e.Button == this.toolBarButtonUngroup )
				//To UnGroup the Grouped symbols
				this.diagram1.Controller.UnGroup();
			else
			{
				// Activate the Tool that corresponds to the clicked toolbar button
				if(sender is ToolBar)
				{
					ToolBar tbsender = sender as ToolBar;
					foreach(ToolBarButton btn in tbsender.Buttons)
					{
						btn.Pushed = false;
					}
				}
				string toolName = (string) e.Button.Tag;				
				Tool toolToActivate = this.diagram1.Controller.GetTool( toolName );
				if( toolToActivate != null )
				{
					toolToActivate.SingleActionTool = false;
					//To activate the the tool chosen
					this.diagram1.Controller.ActivateTool( toolToActivate );
					e.Button.Pushed = true;
				}
			}
		}
		#endregion

		#region Methods to add and remove informations from images
		//Method to add text to image
		private void AddInfotoImage()
		{
			TextNode txtnode = new TextNode();
			//Text to appear with the image
			txtnode.Text = "Image created using Syncfusion Essential Diagram";
			//To Create textnode as to display the entire text
			txtnode.SizeToText(new SizeF(0,0));
			txtnode.Name = "ImageInfo";
			txtnode.BackgroundStyle.Color = Color.Azure;
			txtnode.FontStyle.Name = "Verdana";
			//Location of the TextNode
            PointF location = new PointF((this.diagram1.Model.Width/2 - txtnode.Width/2),(this.diagram1.Model.Height-(2*(txtnode.Height))));
			//To add the textnode to the image
			InsertNodesCmd inscmd = new InsertNodesCmd( this.diagram1.Controller.Model, txtnode, location );
			this.diagram1.Controller.ExecuteCommand(inscmd);
		}

		//Method to remove information from the image
		private void RemoveInfofromImage()
		{
			//Gets the textnode of given name
			TextNode tnode = (TextNode)this.diagram1.Model.Nodes.GetNodeByName("ImageInfo");
			if (tnode!=null)
			{
                //Command used to remove nodes
				RemoveNodesCmd rmcmd = new RemoveNodesCmd();
				//removes the particular node
				rmcmd.Nodes.Add(tnode);
				this.diagram1.Controller.ExecuteCommand(rmcmd);
			}
			//To refresh the diagram
			this.diagram1.Refresh();
		}
		#endregion

		#region Print and PrintPreview Methods
		//Method called during the print of diagram document
		private void Print()
		{
			//Creates a instance for diagram print document and initializes it with the diagram's view
			System.Drawing.Printing.PrintDocument printDoc = this.diagram1.CreatePrintDocument();
			PrintDialog printDlg = new PrintDialog();
			//The document to be printed chosen
			printDlg.Document = printDoc;
			
			if (printDlg.ShowDialog(this) == DialogResult.OK)
			{
				//Prints the document chosen 
				printDoc.Print();
			}
		}

		//Method for previewing the diagram document before print
		private void PrintPreview()
		{
			//Creates a instance for diagram print document and initializes it with the diagram's view
			System.Drawing.Printing.PrintDocument printDoc = this.diagram1.CreatePrintDocument();
			PrintPreviewDialog printPreviewDlg = new PrintPreviewDialog();
			printPreviewDlg.Document = printDoc;
			//Shows PrintPreview DialogBox
			printPreviewDlg.ShowDialog(this);
		}
		#endregion

		#region ExportImage Menu Event

		//To export image in required format
		private void exportdiagram_menu_Click(object sender, System.EventArgs e)
		{			
			SaveFileDialog saveFileDialog1 = new SaveFileDialog();
			//Formats in which the image can be saved
			saveFileDialog1.Filter = @"Windows Bitmap(*.bmp)|*.bmp|Exchangeable Image Format(*.exif)|*.exif|Graphics Interchange Format(*.gif)|*.gif|Windows Icon Image(*.ico)|*.ico|Joint Photographic Experts Group(*.jpeg)|*.jpeg|W3C Portable Network Graphics(*.png)|*.png|Tag Image File Format(*.tiff)|*.tiff|Enhanced Metafile Format(*.emf)|*.emf|Windows Metafile(*.wmf)|*.wmf";
			//Title of the SaveDialogBox
			saveFileDialog1.Title = "Export Diagram As:";
			
			ImageFormat imgformat = ImageFormat.Bmp;
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				switch(saveFileDialog1.FilterIndex)
				{
					case 1:
						imgformat = ImageFormat.Bmp;
						break;
					case 2:
						imgformat = ImageFormat.Exif;					
						break;
					case 3:
						imgformat = ImageFormat.Gif;					
						break;
					case 4:
						imgformat = ImageFormat.Icon;					
						break;
					case 5:
						imgformat = ImageFormat.Jpeg;					
						break;
					case 6:
						imgformat = ImageFormat.Png;				
						break;
					case 7:
						imgformat = ImageFormat.Tiff;				
						break;
					case 8:
						imgformat = ImageFormat.Emf;
						break;
					case 9:
						imgformat = ImageFormat.Wmf;
						break;

				}
				//Adds information to image
				AddInfotoImage();
				//Saves image in the chosen format
				SaveImage(saveFileDialog1.FileName, imgformat);
				//Removes information from image
				RemoveInfofromImage();
			}
			else
			{
				return;
			}			
		}
		#endregion

		#region Save Methods of images

		//Method for saving image in chosen format
		private void SaveImage(string filename, ImageFormat imageformat )
		{
			if(imageformat == ImageFormat.Emf)
			{
				Image img = this.diagram1.View.ExportDiagramAsImage(true);
				img.Save(filename,imageformat);
			}			
			else	// Export diagram to a metafile
			{
				this.SaveDiagramAsEmf(filename);
			}
		}
		
		// Create a Metafile with the provided file name and draw teh diagram to it.
		private void SaveDiagramAsEmf(string filename)
		{
			// Create a Metafile with the provided file name and draw the diagram to it.
			Image diagramimage = new Bitmap(1, 1, PixelFormat.Format24bppRgb);
			Graphics grfx = Graphics.FromImage(diagramimage);
			IntPtr hdc = grfx.GetHdc();
			Metafile emf = new Metafile(filename, hdc, EmfType.EmfOnly);
			Graphics emfgrfx = Graphics.FromImage(emf);

			this.diagram1.ExportDiagramToGraphics(emfgrfx);

			grfx.ReleaseHdc(hdc);
			grfx.Dispose();
			emfgrfx.Dispose();
			diagramimage.Dispose();
			emf.Dispose();
		}
		#endregion

#if Essential_PDF_Installed
		
		private void pdfdocument_menu_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog saveFileDialog1 = new SaveFileDialog();
			saveFileDialog1.Filter = @"Portable Document Format(*.pdf)|*.pdf|Enhanced Metafile Format(*.emf)|*.emf";
			saveFileDialog1.Title = "Export Diagram As:";
			
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				switch(saveFileDialog1.FilterIndex)
				{
					case 1:
						this.SaveDiagramAsPdf(saveFileDialog1.FileName);										
						break;
					case 2:
						this.SaveDiagramAsEmf(saveFileDialog1.FileName);
						break;					
				}				
			}
			else
			{
				return;
			}	
		}		
		
		// Export the diagram to a metafile, and generate the pdf document from the metafile
		private void SaveDiagramAsPdf(string filename)
		{
			try
			{
				Image diagramimage = new Bitmap(1, 1, PixelFormat.Format24bppRgb);
				Graphics grfx = Graphics.FromImage(diagramimage);
				IntPtr hdc = grfx.GetHdc();
				Metafile emf = new Metafile(hdc, EmfType.EmfOnly);
				Graphics emfgrfx = Graphics.FromImage(emf);

				this.diagram1.ExportDiagramToGraphics(emfgrfx);

				grfx.ReleaseHdc(hdc);
				grfx.Dispose();
				emfgrfx.Dispose();
				diagramimage.Dispose();
				
				//Create a new PDF Document. This object represents the whole PDF document.
				//This document had One page by default. Additional pages have to be added.
				Syncfusion.Pdf.PDFDocument pdfDoc = new Syncfusion.Pdf.PDFDocument();

				//Draw the WMF Image
				pdfDoc.LastPage.Graphics.DrawImage(new PointF( 3, 3 ), emf);  

				//Save the PDF Document to disk.
				pdfDoc.Save(filename);

				//Open the PDF document that was created using Essential PDF.
				System.Diagnostics.Process.Start(filename);	

				emf.Dispose();
			}
			catch(Exception ex)
			{
				Console.WriteLine(ex.Message);
			}
		}

#endif // Essential_PDF_Installed

	}
}
